// SilverlightSample.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "pwinuser.h"
#include "xamlruntime.h"
#include "xrdelegate.h"
#include "xrptr.h"
#include "resource.h"


IXRCheckBoxPtr box;
IXRTextBoxPtr txt;

class BtnEventHandler
{

public:

	HRESULT OnClick(IXRDependencyObject* source,XRMouseButtonEventArgs* args)
	{
		//MessageBox(NULL,TEXT("You pushed the Button"),TEXT("Silverlight for Embedded test"),MB_OK);
		
		XRThreeState Value;

		box->GetIsChecked(&Value);

		if (Value == XRThreeState_Unchecked)
			Value = XRThreeState_Checked;
		else
			Value = XRThreeState_Unchecked;

		box->SetIsChecked(Value);

		return S_OK;
	}
};

class SldEventHandler
{

public:

	HRESULT OnSlide(IXRDependencyObject* source,XRValueChangedEventArgs<float>* args)
	{
		LPWSTR strVal = new WCHAR[32];

		wsprintf(strVal,TEXT("%.2f"),args->NewValue);
		txt->SetText(strVal);

		MessageBeep(0xFFFFFFFF);
		delete strVal;
		//MessageBox(NULL,strVal,TEXT("Slider Value"),MB_OK);
		return S_OK;
		
	}
};


int WINAPI WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR     lpCmdLine,
                     int       nCmdShow)
{
	NKDbgPrintfW(TEXT("Silverlight Sample started"));

	if (!XamlRuntimeInitialize()) {
		NKDbgPrintfW(TEXT("XAML Runtime Initialization failed"));
		return -1;
	}

	HRESULT retcode;

	IXRApplicationPtr app;
	
	if (FAILED(retcode=GetXRApplicationInstance(&app)))
		return -1;

	if (FAILED(retcode=app->AddResourceModule(hInstance)))
		return -1;

	XRWindowCreateParams wp;

	ZeroMemory(&wp, sizeof(XRWindowCreateParams));

	wp.Style       = WS_OVERLAPPED;
	wp.pTitle      = L"TORADEX SILVERLIGHT";
	wp.Left        = 0;
	wp.Top         = 0;

	XRXamlSource xamlsrc;

	xamlsrc.SetResource(hInstance,TEXT("XAML"),MAKEINTRESOURCE(IDR_XAML1));

	IXRVisualHostPtr vhost;

	if (FAILED(retcode=app->CreateHostFromXaml(&xamlsrc, &wp, &vhost)))
		return -1;

	IXRFrameworkElementPtr root;

	if (FAILED(retcode=vhost->GetRootElement(&root)))
		return -1;


	if (FAILED(retcode=root->FindName(TEXT("MyCheck"), &box)))
	{
		NKDbgPrintfW(TEXT("FindName MyCheck failed"));
		return -1;
	}
	
	if (FAILED(retcode=root->FindName(TEXT("MyBox"), &txt)))
	{
		NKDbgPrintfW(TEXT("FindName MyBox failed"));
		return -1;
	}

	IXRSliderPtr sld;

	if (FAILED(retcode=root->FindName(TEXT("MySlider"), &sld)))
		return -1;

	IXRDelegate<XRValueChangedEventArgs<float>>* valueChangeDelegate;

	SldEventHandler gigu;

	if (FAILED(retcode=CreateDelegate(&gigu,&SldEventHandler::OnSlide,&valueChangeDelegate)))
		return -1;

	if (FAILED(retcode=sld->AddValueChangedEventHandler(valueChangeDelegate)))
		return -1;

	IXRButtonBasePtr btn;
	
	if (FAILED(retcode=root->FindName(TEXT("MyButton"), &btn)))
		return -1;

	IXRDelegate<XRMouseButtonEventArgs>* clickdelegate;

	BtnEventHandler handler;

	if (FAILED(retcode=CreateDelegate(&handler,&BtnEventHandler::OnClick,&clickdelegate)))
		return -1;

	if (FAILED(retcode=btn->AddClickEventHandler(clickdelegate)))
		return -1;

	UINT exitcode;

	if (FAILED(retcode=vhost->StartDialog(&exitcode)))
		return -1;

	clickdelegate->Release();

	valueChangeDelegate->Release();

    return 0;
}



